## GtkEventBox

GtkEventBox — A widget used to catch events for widgets which do not have their own window

## Functions

GtkWidget * | gtk_event_box_new ()
void | gtk_event_box_set_above_child ()
gboolean | gtk_event_box_get_above_child ()
void | gtk_event_box_set_visible_window ()
gboolean | gtk_event_box_get_visible_window ()

## Properties

gboolean | above-child | Read / Write
gboolean | visible-window | Read / Write

## Types and Values

struct | GtkEventBox
struct | GtkEventBoxClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBin
                        ╰── GtkEventBox

## Implemented Interfaces

GtkEventBox implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkEventBox widget is a subclass of GtkBin which also has its own window. It is useful since it allows you to catch events for widgets which do not have their own window.

## Functions

### gtk_event_box_new ()

    GtkWidget *
    gtk_event_box_new (void);

Creates a new GtkEventBox.

#### Returns

a new GtkEventBox

### gtk_event_box_set_above_child ()

    void
    gtk_event_box_set_above_child (GtkEventBox *event_box,
                                   gboolean above_child);

Set whether the event box window is positioned above the windows of its child, as opposed to below it. If the window is above, all events inside the event box will go to the event box. If the window is below, events in windows of child widgets will first got to that widget, and then to its parents.

The default is to keep the window below the child.

#### Parameters

event_box | a GtkEventBox |
above_child | `TRUE` if the event box window is above its child |

Since: 2.4

### gtk_event_box_get_above_child ()

    gboolean
    gtk_event_box_get_above_child (GtkEventBox *event_box);

Returns whether the event box window is above or below the windows of its child. See `gtk_event_box_set_above_child()` for details.

#### Parameters

event_box | a GtkEventBox |

#### Returns

`TRUE` if the event box window is above the window of its child

Since: 2.4

### gtk_event_box_set_visible_window ()

    void
    gtk_event_box_set_visible_window (GtkEventBox *event_box,
                                      gboolean visible_window);

Set whether the event box uses a visible or invisible child window. The default is to use visible windows.

In an invisible window event box, the window that the event box creates is a `GDK_INPUT_ONLY` window, which means that it is invisible and only serves to receive events.

A visible window event box creates a visible (`GDK_INPUT_OUTPUT`) window that acts as the parent window for all the widgets contained in the event box.

You should generally make your event box invisible if you just want to trap events. Creating a visible window may cause artifacts that are visible to the user, especially if the user is using a theme with gradients or pixmaps.

The main reason to create a non input-only event box is if you want to set the background to a different color or draw on it.

There is one unexpected issue for an invisible event box that has its window below the child. (See `gtk_event_box_set_above_child()`.) Since the input-only window is not an ancestor window of any windows that descendent widgets of the event box create, events on these windows aren’t propagated up by the windowing system, but only by GTK+. The practical effect of this is if an event isn’t in the event mask for the descendant window (see `gtk_widget_add_events()`), it won’t be received by the event box.

This problem doesn’t occur for visible event boxes, because in that case, the event box window is actually the ancestor of the descendant windows, not just at the same place on the screen.

#### Parameters

event_box | a GtkEventBox |
visible_window | `TRUE` to make the event box have a visible window |

Since: 2.4

### gtk_event_box_get_visible_window ()

    gboolean
    gtk_event_box_get_visible_window (GtkEventBox *event_box);

Returns whether the event box has a visible window. See `gtk_event_box_set_visible_window()` for details.

#### Parameters

event_box | a GtkEventBox |

#### Returns

`TRUE` if the event box window is visible

Since: 2.4

## Types and Values

### struct GtkEventBox

    struct GtkEventBox;

### struct GtkEventBoxClass

    struct GtkEventBoxClass {
      GtkBinClass parent_class;
    };

#### Members

## Property Details

### The `“above-child”` property

      “above-child”              gboolean

Whether the event-trapping window of the eventbox is above the window of the child widget as opposed to below it.

Owner: GtkEventBox

Flags: Read / Write

Default value: FALSE

### The `“visible-window”` property

      “visible-window”           gboolean

Whether the event box is visible, as opposed to invisible and only used to trap events.

Owner: GtkEventBox

Flags: Read / Write

Default value: TRUE